const sqlite3 = require('sqlite3').verbose()



const dbRoute = '/root/tea_project/rascunhos.db';


async function writingPlanetheDb() {
    const planetheProvDb_raw = require('./readingProvPlanethe');
    const planetheFixDb_raw = require('./readingFixPlanethe');


    let db = new sqlite3.Database(dbRoute, err =>{
        console.log(err);
    })
    var planetheProvDb = await planetheProvDb_raw.planetheProvDb().then((te) => {return te})
    var planetheFixDb = await planetheFixDb_raw.planetheFixDb().then((te) =>{return te})
    
    var newProduct = []
    var changes = []
    var prov_dict = {}
    planetheProvDb.forEach((row) =>{
        prov_dict[row.producto] = row.precio
    })
    var fix_dict = {}
        planetheFixDb.forEach((row) =>{
            fix_dict[row.producto] = {'categoria': row.categoria, 'precio_nuevo': row.precio_nuevo, 'precio_viejo': row.precio_viejo, 'variacion': row.variacion, 'date': row.date}
        })
    var d = new Date();
    if (Object.keys(planetheFixDb).length == 0){
        for(const[key, value] of Object.entries(planetheProvDb)){
            db.run("INSERT INTO planethe_fix(categoria, producto, precio_viejo, precio_nuevo, variacion, date) VALUES(?,?,?,?,?,?);", 
                            [value.categoria, value.producto, value.precio, value.precio, 0, `${d.getFullYear()}-${d.getMonth()+1}-${d.getDate()}`], (err) =>{
                                if(err){
                                    console.log(`${value.producto} couldn't be inserted in the db`);
                                    console.log(err)
                                }
                            })
        }
    }else{

        var variacion
        for(const[key, value] of Object.entries(prov_dict))
        try{
            if (fix_dict[key].precio_viejo != value){ //aquí se compara los precios recíen crawleados con los ya existentes, value es el reciente
                variacion = (fix_dict[key].precio_viejo/value).toFixed(2);
                changes.push([key, value, variacion]);
                db.run("UPDATE planethe_fix SET categoria = ?,  precio_viejo = ?, precio_nuevo = ?, variacion = ?, date = ? WHERE producto = ?;", 
                        [fix_dict[key].categoria, fix_dict[key].precio_nuevo, value, variacion, `${d.getFullYear()}-${d.getMonth()+1}-${d.getDate()}`, key],(err) =>{
                    if(err){
                        console.log(`The Database could not be updated with this product ${key}`)
                    }
                    console.log("theorically it was updated")
                })
            }
        }catch(e)
        {
            newProduct.push([key, value])
            console.log(e)
        }
        
    }
    db.close();
    return[changes, newProduct] //array with the changes in the prices and the new products
};
//writingPlanetheDb(planetheProvDb, planetheFixDb)
module.exports.writingPlanetheDb = writingPlanetheDb